'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var highlightClassName = 'react-highlight';
var styles = "\n  .".concat(highlightClassName, " {\n    background-color: #f8ffb4;\n    transition: all 0.5s ease-in-out;\n  }\n");
var styleSheet = document.createElement('style');
styleSheet.type = 'text/css';
styleSheet.innerText = styles;
document.head.appendChild(styleSheet);

var ChangeHighlight = (function (_ref) {
  var children = _ref.children,
      _ref$showAfter = _ref.showAfter,
      showAfter = _ref$showAfter === void 0 ? 500 : _ref$showAfter,
      _ref$hideAfter = _ref.hideAfter,
      hideAfter = _ref$hideAfter === void 0 ? 2500 : _ref$hideAfter,
      _ref$containerClassNa = _ref.containerClassName,
      containerClassName = _ref$containerClassNa === void 0 ? '' : _ref$containerClassNa,
      _ref$highlightStyle = _ref.highlightStyle,
      highlightStyle = _ref$highlightStyle === void 0 ? highlightClassName : _ref$highlightStyle,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled;

  var _useState = React.useState(),
      _useState2 = _slicedToArray(_useState, 2),
      myChildren = _useState2[0],
      setMyChildren = _useState2[1];

  var isInitialMount = React.useRef(true);

  var showHighlight = function showHighlight(element) {
    var showAfter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : showAfter;
    var hideAfter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : hideAfter;
    setTimeout(function () {
      if (!element.ref.current.className.includes(highlightStyle)) {
        element.ref.current.className += ' ' + highlightStyle;
        var classNames = element.ref.current.className;
        setTimeout(function () {
          element.ref.current.className = classNames.substr(0, classNames.indexOf(highlightStyle)).trim();
        }, hideAfter);
      }
    }, showAfter);
  };

  React.useEffect(function () {
    if (disabled) return;

    if (isInitialMount.current) {
      isInitialMount.current = false;
      setMyChildren(children);
    } else {
      React__default.Children.map(children, function (newChild, index1) {
        React__default.Children.map(myChildren, function (oldChild, index2) {
          if (index1 === index2) {
            if (newChild.props.children !== oldChild.props.children) {
              setMyChildren(children);

              if (newChild.ref && newChild.props.children) {
                showHighlight(newChild, showAfter, hideAfter);
              }
            }
          }
        });
        return newChild.props.children;
      });
    }
  });
  return React__default.createElement("div", {
    className: containerClassName
  }, children);
});

module.exports = ChangeHighlight;
